DAB_VERSION = "3.18";
DAB_DL_VERSION = 1.49;

BINDING_HEADER_DAB = "|cFFFFFF00DISCORD ACTION BARS v"..DAB_VERSION
BiNDING_HEADER_DAB1 = ""
BiNDING_HEADER_DAB2 = ""
BINDING_NAME_DAB_SPACE = ""
BINDING_NAME_DAB_OPTIONS = "Toggle Options Window"
BINDING_NAME_DAB_DRAGGING = "Toggle Dragging"
BINDING_NAME_DAB_BUTTONIDS = "Toggle Button IDs"
BINDING_NAME_DAB_BUTTONLOCK = "Toggle Button Lock On All Objects"

DAB_PREFIX = "DAB_"
DAB_AB_PREFIX = DAB_PREFIX.."ActionButton_"
DAB_DISPELMAGIC = "Dispel Magic"

DAB_TEXT = {
	Action = "Action",
	ActionID = "Action ID: ",
	ActionUnusable = "Action Unusable",
	AddCondition = "Add Condition",
	AddEvent = "Add Event",
	AddNew = "Add New Event",
	AdvConfig = "Advanced Config",
	Alpha = "Alpha",
	Amount = "Amount",
	AnchorFrame = "Anchor Frame",
	AnchorPoint = "Anchor Point",
	AnchorTo = "Anchor To",
	AutoAttack = "Auto-Attack",
	AutoConfigure = "Auto-Configure",
	AutoConfigureKB = "Auto-configure Keybindings When Changing Bar Layouts",
	BackgroundAlpha = "Background Alpha",
	BackgroundColor = "Background Color",
	BackgroundMouseoverColor = "Background Mouseover Color",
	BackgroundMouseoverAlpha = "Background Mouseover Alpha",
	BackgroundTexture = "Background Texture",
	BagBar = "Bag Bar",
	Bar = "Bar",
	Bars = "ACTION BARS",
	BarAppearance = "Bar Config";
	BarControl = "Bar Control",
	BarOptions = "BAR $n OPTIONS",
	BarPageDown = "Bar $b Page Down",
	BarPageUp = "Bar $b Page Up",
	BindMe = "BIND ME",
	Border = "Border",
	BorderAlpha = "Border Alpha",
	BorderColor = "Border Color",
	BorderMouseoverColor = "Border Mouseover Color",
	BorderMouseoverAlpha = "Border Mouseover Alpha",
	BorderTexture = "Border Texture",
	Bottom = "Bottom",
	BuffName = "Buff/Debuff Name",
	Button = "Button",
	ButtonAlpha = "Button Alpha",
	ButtonAppearance = "Adv. Bar Config",
	ButtonBackground = "Button Background",
	ButtonBorderAlpha = "Button Border Alpha",
	ButtonBorderPadding = "Button Border Padding:",
	ButtonConditionalColor = "Button Conditional Color",
	ButtonControl = "Button Control",
	ButtonID = "Button ID: ",
	ButtonLayout = "Buttons Per Bar",
	Buttons = "Buttons:",
	ButtonSize = "Button Size",
	ButtonText = "Bttn Text (hide|color|size|font)",
	ButtonTextures = "Button Textures",
	CDFormat = "Cooldown Count Format:",
	ChangeActions = "Change Actions",
	Checked = "Checked",
	ChooseAction = "CHOOSE ACTION",
	ChooseCondition = "Choose Condition",
	ChooseEvent = "Choose Event:",
	ChooseResponse = "Choose Response",
	ChooseScript = "Choose Script",
	CollapseHidden = "Collapse Hidden Buttons",
	Color = "Color",
	Comparison = "Comparison",
	Conditions = "ACTIVE CONDITIONS",
	Config = "Config",
	Control = "Control",
	ControlBarPage = "Change A Bar's Page On Click",
	ControlBox = "Control Box",
	ControlBoxes = "CONTROL BOXES",
	ControlBoxGroup = "Control Box Group",
	ControlBoxOptions = "CONTROL BOX $n OPTIONS",
	ControlledGroup = "Group This Box Controls",
	CooldownCount = "Cooldown Count",
	CopyAll = "COPY ALL",
	Count = "Count",
	CtrlBox = "Ctrl Box",
	CurrentProfile = "Current Profile:",
	Desc = "Desc:",
	Default = "Default",
	DefaultTarget = "Default Target",
	Delete = "Delete",
	DisableMouseOnBar = "Disable Mouse Input On Bar Background",
	DisableMousewheel = "Disable Mousewheel Paging",
	DisableTooltip = "Disable Tooltip",
	DisplayBarPage = "Display Bar's Page Number",
	DynamicKeybinding = "Dynamic Keybinding",
	EdgeSize = "Edge Size",
	Edit = "Edit",
	ElementScripts = "Element Scripts",
	Equipped = "Equipped",
	EventScripts = "OnEvent Scripts",
	ExpandHidden = "Show Hidden Buttons When Dragging an Action",
	Filters = "Filters:",
	FloaterOptions = "FLOATER $n OPTIONS: $a",
	Floater = "Floater",
	Floaters = "FLOATERS",
	Font = "Font",
	FontSize = "Font Size",
	Force = "Force",
	ForceSelfCast = "Force Self-cast:",
	Form = "Stance/Animal Form/Stealth",
	FrameStrata = "Frame Strata",
	FreeButtons = "Buttons Available:",
	Event = "Event:",
	Group = "Group",
	Height = "Height",
	Hide = "Hide",
	HideActionIDs = "Hide Action IDs",
	HideAllLabels = "Hide All Labels",
	HideBackdrop = "Hide Backdrop",
	HideButtonIDs = "Hide Button IDs",
	HideEmpty = "Hide Empty Buttons",
	HideEverything = "Hide Main Menu Bar Art",
	HideGlobalCooldownCount = "Hide Global",
	HideGroups = "Hide Groups On Click",
	HideOnClick = "Hide On Click",
	Highlight = "Highlight",
	IgnoreGlobal = "Ignore Global Cooldown",
	Insets = "Insets:",
	JustifyH = "Horiz. Justification",
	JustifyV = "Vert. Justification",
	KBWarning = "Use the DAB keybindings below.",
	Key1 = "Key 1",
	Key2 = "Key 2",
	Keybinding = "Keybinding",
	Keybindings = "Keybindings",
	KeyringControl = "Let DAB control the keyring button",
	KeyringScale = "Keyring Button Scale",
	Label = "Label",
	LatencyScale = "Latency Scale",
	Layout = "Layout",
	Left = "Left",
	LoadProfile = "Load Profile:",
	LockButton = "Lock Button",
	LockButtons = "Lock Buttons",
	LockDragging = "Lock Dragging",
	MacroName = "Macro Name",
	MainBarOptions = "Main Menu Bar",
	MenuBar = "Micro Menu Bar",
	MiddleClickBar = "Middle-click Bar",
	MiddleClickButton = "Middle-click Action",
	MiscOptions = "Misc Options",
	ModifyTooltip = "Show Action and Button ID's in a button's tooltip",
	MouseoutDelay = "Delay On Mouseout",
	Name = "Name:",
	NewProfile = "New Profile: ",
	NotEnoughMana = "Not Enough Mana",
	Number = "Number",
	NumButtonsPerBar = "Button Layout",
	ObjectOptions = "OBJECT OPTIONS",
	OnEventScripts = "ON EVENT SCRIPTS",
	Options = "Options",
	OptionsScale = "Options Window Scale",
	OtherBars = "OTHER BARS",
	OutOfRange = "Out of Range",
	OverrideButtonLock = "Override Button Lock:",
	OverrideDragLock = "Override Dragging Lock:",
	Overrides = "Overridden By:",
	Padding = "Padding:",
	Page = "Page",
	Page2 = "Page It Replaces",
	Pages = "Pages:",
	Parameters = "PARAMETERS:",
	PetAutoAttack = "Pet Auto-Attack",
	PetBar = "Pet Action Bar",
	PresetBackdrops = "Preset Backdrops",
	Recolor = "Recolor",
	Response = "Response:",
	Right = "Right",
	RightClickBar = "Right-click Bar",
	RightClickButton = "Right-click Action",
	Rows = "Rows",
	RunOn = "Run On Key:",
	RunOnDown = "Down",
	RunOnUp = "Up",
	SafeLoad = "SAFE LOAD",
	Scale = "Button Scale",
	Scripts = "Scripts",
	SetActionIDs = "Set Action IDs",
	SetBarPage = "Set Bar $b to Page $p",
	SetKBGroup = "Set Group $g to Bar $b",
	ShapeshiftBar = "Shapeshift Bar",
	ShowActionIDs = "Show Action IDs",
	ShowButtonIDs = "Show Button IDs",
	ShowCooldownCount = "Show Cooldown Count",
	ShowLatency = "Let DAB Control Latency Bar",
	ShowOnMouseover = "Show On Mouseover",
	ShowXP = "Let DAB Control XP Bar",
	SkipPages = "Skip Pages",
	SpacingH = "Horizontal Spacing",
	SpacingV = "Vertical Spacing",
	Text = "Text",
	TextAlpha = "Text Alpha",
	TextColor = "Text Color",
	TextMouseoverAlpha = "Text Mouseover Alpha",
	TextMouseoverColor = "Text Mouseover Color",
	Texture = "Texture",
	Tile = "Tile",
	TileSize = "Tile Size",
	ToggleGroupOnClick = "Toggle Group On Click",
	ToggleGroupOnRightClick = "Toggle Group On Right-click",
	ToggleGroupOnMiddleClick = "Toggle Group On Middle-click",
	ToggleGroupOnMouseover = "Toggle Group On Mouseover",
	Top = "Top",
	TotalUsed = "Total Used:",
	TrimEdges = "Trim Button Edges",
	Type = "Type",
	Undefined = "Undefined",
	Unit = "Unit",
	UnlockDragging = "Unlock Dragging",
	UpdateSpeed = "Updates Per Second",
	VariableKeybinding = "Variable Keybinding $n",
	Warning = "Not enough buttons available.\nFree up |cFFAAAAFF$n|cFFFFFF00 buttons.",
	Width = "Width",
	XPAlpha = "XP Bar Alpha",
	XPBorderColor = "XP Border Color",
	XPColor = "XP Bar Color",
	XPHideBorder = "Hide XP Bar Border",
	XPScale = "XP Bar Scale",
}

DAB_HELP_TEXT = {
	"Discord Action Bars Slash Commands",
	"------------------------------------------------------",
	"/dab - toggle the options window",
	"/dab barshow # - show bar #",
	"/dab barhide # - hide bar #",
	"/dab bartoggle # - show bar # if it's hidden else hide it",
	"/dab floatershow # - show floater #",
	"/dab floaterhide # - hide floater #",
	"/dab floatertoggle # - show floater # if it's hidden else hide it",
	"/dab clearbar # - removes the actions from all buttons on bar #",
	"/dab hideallbars - hide all bars",
	"/dab showallbars - show all bars",
	"/dab setkeygroup group# bar# - sets a keybinding group to the bar",
	"/dab groupshow # - shows all objects set to control box group #",
	"/dab grouphide # - hides all objects set to control box group #",
	"/dab grouptoggle # - toggles all objects set to control box group #",
	"/dab drag - toggles the dragging lock",
	"/dab ids - toggles showing action IDs inside the buttons",
	"/dab load profilename - loads the specified profile"
};

DAB_RECOLOR = {
	{ text = "Icon", value = 1 },
	{ text = "Border", value = 2 },
	{ text = "Keybinding Text", value = 3 }
}

DAB_BAR_RESPONSES = {
	{ text="No Response", value=0, desc="Doesn't do anything.  Useful for condtions which are only overrides." },
	{ text="Change Page", value=1, desc="Changes the page of this bar to the page you choose." },
	{ text="Remap Page", value=32, desc="Causes the page of your choice to replace another page." },
	{ text="Hide", value=2, desc="Hides this bar." },
	{ text="Show", value=3, desc="Shows this bar." },
	{ text="Set Alpha", value=4, desc="Sets the transparency of the entire bar." },
	{ text="Set Background Alpha", value=5, desc="Sets the transparency of the bar's background." },
	{ text="Set Background Color", value=6, desc="Sets the color of the bar's background." },
	{ text="Set Border Alpha", value=7, desc="Sets the transparency of the bar's border." },
	{ text="Set Border Color", value=8, desc="Sets the color of the bar's border." },
	{ text="Set Button Alpha", value=9, desc="Sets the transparency of all the bar's buttons." },
	{ text="Set Button Size", value=19, desc="Sets the size of all the bar's buttons." },
	{ text="Set Button Border Color", value=20, desc="Sets the border color of all the bar's buttons." },
	{ text="Apply Keybinding Group", value=10, desc="Applies a group of keybindings to this bar.  Keybinding groups are created in the Keybindings window brought up with the button to the left." },
	{ text="Move To Location", value=35, desc="Lets you specify X and Y offsets to move the bar to.  It will remain relative to its anchor frame and points." },
	{ text="Move Up", value=11, desc="Moves the bar up by the specified amount." },
	{ text="Move Down", value=12, desc="Moves the bar down by the specified amount." },
	{ text="Move Left", value=13, desc="Moves the bar left by the specified amount." },
	{ text="Move Right", value=14, desc="Moves the bar right by the specified amount." },
	{ text="Move Under Mouse Cursor", value=21, desc="Moves the center of the bar to a point directly beneath the mouse cursor." },
	{ text="Return to Previous Page", value=22, desc="Returns the bar to the page it was on before the last time its page was changed." },
	{ text="Set Top BG Padding", value=15, desc="Sets the amount of space between the top border and the bar's buttons." },
	{ text="Set Bottom BG Padding", value=16, desc="Sets the amount of space between the bottom border and the bar's buttons."  },
	{ text="Set Left BG Padding", value=17, desc="Sets the amount of space between the left border and the bar's buttons." },
	{ text="Set Right BG Padding", value=18, desc="Sets the amount of space between the right border and the bar's buttons." },
	{ text="Set Bar Target", value=33, desc="Lets you specify a unit ID all buttons on the bar will automatically target.  The unit will always be targetted by the bar until the target is removed by the response below." },
	{ text="Remove Bar Target", value=34, desc="Removes a target override set by the Set Bar Target response." },
	{ text="Hide Bar", value=102, desc="Hides a bar of your choice." },
	{ text="Show Bar", value=103, desc="Shows a bar of your choice." },
	{ text="Hide Control Box", value=104, desc="Hides a control box of your choice." },
	{ text="Show Control Box", value=105, desc="Shows a control box of your choice." },
	{ text="Hide Floater", value=106, desc="Hides a floater of your choice." },
	{ text="Show Floater", value=107, desc="Shows a floater of your choice." },
	{ text="Chat Frame Message", value=100, desc="Sends a message to your default chat frame that only you see." },
	{ text="Floating Message", value=101, desc="Places a message at the top of the screen that slowly fades away.  It's similar to when you loot a quest item." },
	{ text="Set Variable to True", value=108, desc="Sets a variable's value to true.  Type in the name of any variable.  Doesn't have to be an existing variable." },
	{ text="Set Variable to False", value=109, desc="Sets a variable's value to false.  Type in the name of any variable.  Doesn't have to be an existing variable." },
	{ text="Set Timer", value=113, desc="Set a timer that counts down invisibly for use in condition checking.  Give the timer an id with the Text editbox and enter the seconds in the Number editbox."},
	{ text="Play Sound", value=114, desc="Type in the path and filename of the sound to play."},
	{ text="Run Script", value=115, desc="Type in lua code for the Text parameter and it will be executed."},
}

DAB_FLOATER_RESPONSES = {
	{ text="No Response", value=0, desc="Doesn't do anything.  Useful for condtions which are only overrides." },
	{ text="Hide", value=2, desc="Hides this floater." },
	{ text="Show", value=3, desc="Shows this floater." },
	{ text="Remove Color", value=28, desc="Returns the floater to normal recoloring based on mana, range, etc. after a Set Color response." },
	{ text="Set Alpha", value=4, desc="Sets the transparency of the floater." },
	{ text="Set Color", value=22, desc="Sets the color of the floater." },
	{ text="Set Size", value=19, desc="Sets the size of the floater." },
	{ text="Set Border Alpha", value=7, desc="Sets the transparency of the floater's border." },
	{ text="Set Border Color", value=8, desc="Sets the color of the floater's border." },
	{ text="Set Keybinding", value=23, desc="Sets a particular keybinding to apply to this floater.  Type in the number of the keybinding.  A keybinding's number is the little yellow number that is shown to the left of a keybinding in DAB's Keybindings window." },
	{ text="Move To Location", value=35, desc="Lets you specify X and Y offsets to move the floater to.  It will remain relative to its anchor frame and points." },
	{ text="Move Up", value=11, desc="Moves the floater up on the screen." },
	{ text="Move Down", value=12, desc="Moves the floater down on the screen." },
	{ text="Move Left", value=13, desc="Moves the floater left on the screen." },
	{ text="Move Right", value=14, desc="Moves the floater right on the screen." },
	{ text="Move Under Mouse Cursor", value=21, desc="Moves the center of the floater to a point directly beneath the mouse cursor." },
	{ text="Set Action", value=29, desc="Let's you change this button's action to any action." },
	{ text="Start Blinking", value=24, desc="Starts the floater fading in and out repeatedly." },
	{ text="Stop Blinking", value=25, desc="Stops the floater from fading in and out repeatedly." },
	{ text="Start Flashing", value=26, desc="Starts the red flashing you see when you have an auto-attack action enabled." },
	{ text="Stop Flashing", value=27, desc="Stops the floater from flashing." },
	{ text="Enable Button", value=30, desc="Re-enables mouse clicks and keybindings for the button." },
	{ text="Disable Button", value=31, desc="Disables mouse clicks and keybindings on the button." },
	{ text="Set Button Target", value=33, desc="Lets you specify a unit ID the button will automatically target.  The unit will always be targetted by the button until the target is removed by the response below." },
	{ text="Remove Button Target", value=34, desc="Removes a target override set by the Set Button Target response." },
	{ text="Hide Bar", value=102, desc="Hides a bar of your choice." },
	{ text="Show Bar", value=103, desc="Shows a bar of your choice." },
	{ text="Hide Control Box", value=104, desc="Hides a control box of your choice." },
	{ text="Show Control Box", value=105, desc="Shows a control box of your choice." },
	{ text="Hide Floater", value=106, desc="Hides a floater of your choice." },
	{ text="Show Floater", value=107, desc="Shows a floater of your choice." },
	{ text="Chat Frame Message", value=100, desc="Sends a message to your default chat frame that only you see." },
	{ text="Floating Message", value=101, desc="Places a message at the top of the screen that slowly fades away.  It's similar to when you loot a quest item." },
	{ text="Set Variable to True", value=108, desc="Sets a variable's value to true.  Type in the name of any variable.  Doesn't have to be an existing variable." },
	{ text="Set Variable to False", value=109, desc="Sets a variable's value to false.  Type in the name of any variable.  Doesn't have to be an existing variable." },
	{ text="Set Timer", value=113, desc="Set a timer that counts down invisibly for use in condition checking.  Give the timer an id with the Text editbox and enter the seconds in the Number editbox."},
	{ text="Play Sound", value=114, desc="Type in the path and filename of the sound to play."},
	{ text="Run Script", value=115, desc="Type in lua code for the Text parameter and it will be executed."},
}

DAB_BUTTONBAR_RESPONSES = {
	{ text="No Response", value=0, desc="Doesn't do anything.  Useful for condtions which are only overrides." },
	{ text="Hide", value=2, desc="Hides this button." },
	{ text="Show", value=3, desc="Shows this button." },
	{ text="Remove Color", value=28, desc="Returns this button to normal recoloring based on mana, range, etc. after a Set Color response." },
	{ text="Set Action", value=29, desc="Let's you change this button's action to any action." },
	{ text="Set Alpha", value=4, desc="Sets the transparency of this button." },
	{ text="Set Color", value=22, desc="Sets the color of this button." },
	{ text="Start Blinking", value=24, desc="Starts the button fading in and out repeatedly." },
	{ text="Stop Blinking", value=25, desc="Stops the button from fading in and out repeatedly." },
	{ text="Start Flashing", value=26, desc="Starts the red flashing you see when you have an auto-attack action enabled." },
	{ text="Stop Flashing", value=27, desc="Stops the button from flashing." },
	{ text="Enable Button", value=30, desc="Re-enables mouse clicks and keybindings for the button." },
	{ text="Disable Button", value=31, desc="Disables mouse clicks and keybindings on the button." },
	{ text="Set Button Target", value=33, desc="Lets you specify a unit ID the button will automatically target.  The unit will always be targetted by the button until the target is removed by the response below." },
	{ text="Remove Button Target", value=34, desc="Removes a target override set by the Set Button Target response." },
	{ text="Hide Bar", value=102, desc="Hides a bar of your choice." },
	{ text="Show Bar", value=103, desc="Shows a bar of your choice." },
	{ text="Hide Control Box", value=104, desc="Hides a control box of your choice." },
	{ text="Show Control Box", value=105, desc="Shows a control box of your choice." },
	{ text="Hide Floater", value=106, desc="Hides a floater of your choice." },
	{ text="Show Floater", value=107, desc="Shows a floater of your choice." },
	{ text="Chat Frame Message", value=100, desc="Sends a message to your default chat frame that only you see." },
	{ text="Floating Message", value=101, desc="Places a message at the top of the screen that slowly fades away.  It's similar to when you loot a quest item." },
	{ text="Set Variable to True", value=108, desc="Sets a variable's value to true.  Type in the name of any variable.  Doesn't have to be an existing variable." },
	{ text="Set Variable to False", value=109, desc="Sets a variable's value to false.  Type in the name of any variable.  Doesn't have to be an existing variable." },
	{ text="Set Timer", value=113, desc="Set a timer that counts down invisibly for use in condition checking.  Give the timer an id with the Text editbox and enter the seconds in the Number editbox."},
	{ text="Play Sound", value=114, desc="Type in the path and filename of the sound to play."},
	{ text="Run Script", value=115, desc="Type in lua code for the Text parameter and it will be executed."},
}

DAB_EVENTS = {
	{ text="Party Members Changed", value="PARTY_MEMBERS_CHANGED", desc="Thrown when players leave or join your party." },
	{ text="Pet Attack Start", value="PET_ATTACK_START", desc="Thrown when your pet starts attacking." },
	{ text="Pet Attack Stop", value="PET_ATTACK_STOP", desc="Thrown when your pet stops attacking." },
	{ text="Player Auto-Attack Start", value="PLAYER_ENTER_COMBAT", desc="Thrown when you start auto-attacking with a melee weapon." },
	{ text="Player Auto-Attack Stop", value="PLAYER_LEAVE_COMBAT", desc="Thrown when you stop auto-attacking with a melee weapon." },
	{ text="Player Combo Points", value="PLAYER_COMBO_POINTS", desc="Thrown when you gain or lose combo points." },
	{ text="Player Gained Threat", value="PLAYER_REGEN_DISABLED", desc="Thrown when you do anything to gain threat: damage a mob, heal someone attacking the mob, etc." },
	{ text="Player Lost Threat", value="PLAYER_REGEN_ENABLED", desc="Thrown when you've lost all threat." },
	{ text="Player Target Changed", value="PLAYER_TARGET_CHANGED", desc="Thrown when you change targets." },
	{ text="Raid Members Changed", value="RAID_ROSTER_UPDATE", desc="Thrown when players leave or join your raid." },
	{ text="Unit Buffs/Debuffs Changed", value="UNIT_AURA", desc="Thrown when you, any party member, and any raid member gains a new buff/debuff or loses a buff/debuff.\narg1 = unit ID of the unit who's buffs changed" },
	{ text="Unit's Energy Changed", value="UNIT_ENERGY", desc="Thrown when you, any party member, and any raid member gain or lose energy.\narg1 = unit ID of the unit who's energy changed" },
	{ text="Unit's Focus Changed", value="UNIT_FOCUS", desc="Thrown when your pet or any party member's pet gains or loses focus.\narg1 = unit ID of the unit who's focus changed" },
	{ text="Unit's Health Changed", value="UNIT_HEALTH", desc="Thrown when you, any party member, and any raid member gain or lose health.\narg1 = unit ID of the unit who's health changed" },
	{ text="Unit's Mana Changed", value="UNIT_MANA", desc="Thrown when you, any party member, and any raid member gain or lose mana.\narg1 = unit ID of the unit who's mana changed" },
	{ text="Unit's Pet Changed", value="UNIT_PET", desc="Thrown when you or any party members summon or unsummon a pet.\narg1 = unit ID of the pet that was summoned or unsummoned" },
	{ text="Unit's Rage Changed", value="UNIT_RAGE", desc="Thrown when you, any party member, and any raid member gain or lose rage.\narg1 = unit ID of the unit who's rage changed" },
	{ text="Variable Keybinding Pressed", value="VariableKeybinding", desc="Thrown when you press a Variable Keybinding.\narg1 = the number of the keybinding, arg2 = 1 for down, 2 for up"},
	{ text="Variables Loaded", value="VARIABLES_LOADED", desc="Thrown when the mod first loads and whenever you change the script for this event." },
	{ text="You Shapeshift", value="UPDATE_BONUS_ACTIONBAR", desc="Thrown when you stealth, change animal forms, or change stances." },
	{ text="OnUpdate", value="OnUpdate", desc="Thrown a number of times per second equal to the Updates Per Second you set.\narg1 = time elapsed in seconds since the last time this event was thrown" }
}

DAB_SCRIPTS = {
	{text="OnClick - After", value=2, desc="Runs when you click the object.\nRuns after DAB's regular click processing.\nparam = the button clicked: LeftButton, RightButton, MiddleButton,\nButton4, Button5"},
	{text="OnClick - Before", value=12, desc="Runs when you click the object.\nRuns before DAB's regular click processing.\nparam = the button clicked: LeftButton, RightButton, MiddleButton,\nButton4, Button5"},
	{text="OnEnter", value=3, desc="Runs repeatedly as you move the mouse over the object.\nObject must be shown."},
	{text="OnEvent", value=8, desc="Runs whenever an event is thrown the\nobject is registered to monitor."},
	{text="OnHide", value=6, desc="Runs once each time the object is hidden."},
	{text="OnKeybindingDown - After", value=10, desc="Runs once when the keybinding for this object\nis pressed down.\nparam = the button ID of the button's who's binding was pressed"},
	{text="OnKeybindingDown - Before", value=13, desc="Runs once when the keybinding for this object\nis pressed down.\nparam = the button ID of the button's who's binding was pressed"},
	{text="OnKeybindingUp - After", value=11, desc="Runs once when the keybinding for this object\nis released.\nparam = the button ID of the button's who's binding was pressed"},
	{text="OnKeybindingUp - Before", value=14, desc="Runs once when the keybinding for this object\nis released.\nparam = the button ID of the button's who's binding was pressed"},
	{text="OnLeave", value=4, desc="Runs once when the mouse is moved off the object.\nObject must be shown."},
	{text="OnLoad", value=1, desc="Runs once when the mod loads or when you\nchange this script."},
	{text="OnMouseWheel", value=9, desc="Runs when the mousewheel is scrolled while\nthe cursor is over the object."},
	{text="OnShow", value=5, desc="Runs once each time the object is shown."},
	{text="OnUpdate", value=7, desc="Runs a number of times per second while object's shown.\nparam = time elapsed since last run"}
}

DAB_KEYBINDING_OPTIONS = {
	{text="", value=0, desc="Set the keybinding to do nothing."},
	{text="Bar", value=1, desc="Set this keybinding to press a specific button on a specific bar.  The middle drop-down menu is where you select the bar.  The right drop-down menu is where you select the button.  These keybindings are shared across all of the bar's pages."},
	{text="Group", value=2, desc="Set this keybinding to be part of a group of keybindings.  Keybinding groups can be applied to different bars on the fly."},
	{text="Floater", value=3, desc="Set this keybinding to press a specific floater."},
	{text="Control Box", value=4, desc="Set this keybinding to press a specific control box.  If the control box is set to toggle objects on mouseover then holding the keybinding down acts as a mouseover and releasing the keybinding acts as a mouseout."},
	{text="Apply Group To Bar", value=5, desc="Set this keybinding to apply a specific keybinding group to a specific bar."},
	{text="Set Bar Page", value=6, desc="Set this keybinding to change a bar to the page you specify."},
	{text="Bar Page Up", value = 7, desc="Set this keybinding to change a bar to its next page."},
	{text="Bar Page Down", value = 8, desc="Set this keybinding to change a bar to its previous page."},
	{text="Variable Keybinding", value=9, desc="This is a special keybinding mostly used in an object's conditions when you want to check if a certain key is up or down.  The number you choose in the middle drop-down menu is the number you type for the Variable Keybinding Up/Down conditions."},
	{text="Self-cast Bar", value=10, desc="Set this keybinding to automatically self-cast the action in a specific button on a specific bar."},
	{text="Self-cast Floater", value=11, desc="Set this keybinding to automatically self-cast the action in a specific floater."},
	{text="Button on Bar Page", value=12, desc="Set this keybinding to use the action in a specific button on any page of a bar."},
	{text="Use Action", value=13, desc="This will let you bind a key directly to an action.  That action doesn't have to be in any action button."},
	{text="Self-cast Action", value=14, desc="This will let you bind a key directly to an action.  That action doesn't have to be in any action button.  The action will automatically target you."},
}

DAB_KBO_NO = 0 -- OK
DAB_KBO_BAR = 1 -- OK
DAB_KBO_GROUP = 2
DAB_KBO_FLOATER = 3
DAB_KBO_CONTROL_BOX = 4
DAB_KBO_APPLY_GROUP_TO_BAR = 5
DAB_KBO_SET_BAR_PAGE = 6 -- OK
DAB_KBO_BAR_PAGE_UP = 7 -- OK
DAB_KBO_BAR_PAGE_DOWN = 8 -- OK
DAB_KBO_VARIABLE_KEYBINDING = 9
DAB_KBO_SELF_CAST_BAR = 10 -- OK
DAB_KBO_SELF_CAST_FLOATER = 11
DAB_KBO_BUTTON_ON_BAR_PAGE = 12 -- OK
DAB_KBO_USE_ACTION = 13 -- OK
DAB_KBO_SELF_CAST_ACTION = 14 -- OK

DAB_LAYOUTS = {
	{text="1 Row", value=1},
	{text="2 Rows", value=2},
	{text="1 Column", value=3},
	{text="2 Columns", value=4}
}

DAB_PAGE_CONTROLS = {
	{text="Page Up", value=1},
	{text="Page Down", value=2},
	{text="Set Page", value=3}
}

DAB_ACTIONID_FILTERS = {
	{text="ALL", value=1},
	{text="Floaters", value=2}
}
for b=1,10 do
	DAB_ACTIONID_FILTERS[b + 2] = {text="Bar "..b, value=b+2};
end

DAB_MODIFIER_KEYS = {
	{text="None", value=0},
	{text="Alt", value=1},
	{text="Ctrl", value=2},
	{text="Shift", value=3}
}

DAB_TIME_FORMAT = {
	{text=1, value=1, desc="If cooldown is less than 60 seconds, it displays the seconds remaining.  Otherwise it displays the minutes remaining."},
	{text=2, value=2, desc="Always displays the cooldown as seconds remaining."},
	{text=3, value=3, desc="Displays the cooldown in a mm:ss format."}
}

-- GERMAN LOCALIZATION
if (GetLocale() == "deDE") then
	DAB_DISPELMAGIC = "Magiebannung";
end

-- FRENCH LOCALIZATION
if (GetLocale() == "frFR") then
	DAB_DISPELMAGIC = "Dissiper la magie"
end



-- GLOBALS, DO NOT CHANGE --

DAB_BAR_LIST = {};
DAB_OBJECT_INDEX = 2;
DAB_OBJECT_TYPE = "Bar";
DAB_OBJECT_SUBINDEX = 1;
DAB_CONDITION_BUFFER = {};
DAB_SELECTED_KEYBINDING = {};
DAB_VARIABLE_KEYBINDINGS = {};
DAB_AUTOCAST_QUEUE = {};
DAB_ACTIONIDS_FILTER1 = 1;
DAB_ACTIONIDS_FILTER2 = 1;
DAB_NUM_BARS = 10;
DAB_NUM_BUTTONS = 120;

DAB_OTHER_BAR = {};
for i=11, 14 do
	DAB_OTHER_BAR[i] = {};
end
DAB_OTHER_BAR[11][0] = { tag="_Pet", numButtons=10, offset=0, height=30, width=30 };
DAB_OTHER_BAR[12][0] = { tag="_Form", numButtons=10, offset=0, height=30, width=30 };
DAB_OTHER_BAR[13][0] = { tag="_Bag", numButtons=5, offset=0, height=37, width=37 };
DAB_OTHER_BAR[14][0] = { tag="_Menu", numButtons=8, offset=20, height=38, width=29 };
for i=1,10 do
	DAB_OTHER_BAR[11][i] = "PetActionButton"..i;
	DAB_OTHER_BAR[12][i] = "ShapeshiftButton"..i;
end
DAB_OTHER_BAR[13][5] = "MainMenuBarBackpackButton";
for i=0,3 do
	DAB_OTHER_BAR[13][4 - i] = "CharacterBag"..i.."Slot"
end
DAB_OTHER_BAR[14][1] = "CharacterMicroButton";
DAB_OTHER_BAR[14][2] = "SpellbookMicroButton";
DAB_OTHER_BAR[14][3] = "TalentMicroButton";
DAB_OTHER_BAR[14][4] = "QuestLogMicroButton";
DAB_OTHER_BAR[14][5] = "SocialsMicroButton";
DAB_OTHER_BAR[14][6] = "LFGMicroButton"; -- ehemals "WorldMapMicroButton"
DAB_OTHER_BAR[14][7] = "MainMenuMicroButton";
DAB_OTHER_BAR[14][8] = "HelpMicroButton";

DAB_NUMBERS = {};
for i=1, 10 do
	DAB_NUMBERS[i] = {text=i, value=i};
end

DAB_KB_COLOR = {
	[0] = "777777",
	[1] = {
		"DDDDDD",
		"DDDD00",
		"00FF00",
		"FF3333",
		"4444FF",
		"FF00FF",
		"FF8800",
		"00FFFF",
		"FFAAAA",
		"AAFFAA"
	},
	[2] = "00FFFF",
	[3] = "FFFF00",
	[4] = "FF0000",
	[5] = "00FFFF",
	[6] = "CCCCCC",
	[7] = "CCCCCC",
	[8] = "CCCCCC",
	[9] = "00FF00",
	[10] = {
		"DDDDDD",
		"DDDD00",
		"00FF00",
		"FF3333",
		"4444FF",
		"FF00FF",
		"FF8800",
		"00FFFF",
		"FFAAAA",
		"AAFFAA"
	},
	[11] = "FFFF00",
	[12] = {
		"DDDDDD",
		"DDDD00",
		"00FF00",
		"FF3333",
		"4444FF",
		"FF00FF",
		"FF8800",
		"00FFFF",
		"FFAAAA",
		"AAFFAA"
	},
	[13] = "FFFF00",
	[14] = "FFFF00"
}